<template>
  <v-switch
    v-model="model"
    @update:model-value="update"
    :density="density"
    :color="color"
    :inset="inset"
    class="custom-switch"
    hide-details="auto"
    :ripple="ripple"
  >
    <template v-if="label" #label>
      <p class="text-base text-fake-black font-normal whitespace-nowrap">
        {{ label }}
      </p>
    </template>
  </v-switch>
</template>

<script setup>
import { ref, watch, onMounted } from "vue";

const emit = defineEmits(['update:modelValue']);

onMounted(() => {
  model.value = props?.modelValue;
});

const model = ref(null);

const props = defineProps({
  modelValue: {
    type: String,
    default: '',
  },
  density: {
    type: String,
    default: 'compact',
  },
  color: {
    type: String,
    default: 'primary'
  },
  label: {
    type: String,
    default: ''
  },
  inset: {
    type: Boolean,
    default: true
  },
  ripple: {
    type: Boolean,
    default: true
  },
})

const update = (value) => {
  emit('update:modelValue', value);
}

watch(props, (newValue, oldValue) => {
  if (newValue?.modelValue) {
    model.value = newValue?.modelValue;
  }
})
</script>

<style scoped>
.v-input--switch__track {
  border-radius: 12px;
  width: 46px;
  height: 24px;
  top: 0px;
}

.v-input--switch__thumb {
  left: 4px;
}

.custom-switch .v-input__slot .v-label {
  left: 3px !important
}

.v-input--selection-controls__ripple {
  height: 0;
  width: 0
}
</style>
